"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Button;

var _react = _interopRequireWildcard(require("react"));

var _LibraryContextInit = _interopRequireDefault(require("../Provider/LibraryContextInit"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _cssJSLogic2 = _interopRequireDefault(require("./css/cssJSLogic"));

var _utils = require("@zohodesk/utils");

var _ButtonModule = _interopRequireDefault(require("./css/Button.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Button text and children props?
use children for both cases
toLowerCase check needed?
*/

/* eslint css-modules/no-unused-class: [2, { markAsUsed: ['small','medium','large','xlarge','button_medium','button_small','primary','primaryfilled','danger','dangerfilled','plainprimary', 'plainsecondary', 'secondary', 'secondaryfilled', 'successFilled','tertiaryFilled'] }] */
function Button(props) {
  var text = props.text,
      disabled = props.disabled,
      onClick = props.onClick,
      status = props.status,
      children = props.children,
      dataId = props.dataId,
      needAppearance = props.needAppearance,
      getRef = props.getRef,
      title = props.title,
      dataSelectorId = props.dataSelectorId,
      customProps = props.customProps,
      customStyle = props.customStyle,
      a11y = props.a11y,
      id = props.id;

  var _useContext = (0, _react.useContext)(_LibraryContextInit["default"]),
      a11y_strikeThroughButtons = _useContext.a11y_strikeThroughButtons;

  var finalStyle = (0, _utils.mergeStyle)(_ButtonModule["default"], customStyle);

  var buttonProps = _objectSpread(_objectSpread({}, props || {}), {}, {
    a11y_strikeThroughButtons: a11y_strikeThroughButtons
  });

  var _cssJSLogic = (0, _cssJSLogic2["default"])({
    buttonProps: buttonProps,
    style: finalStyle
  }),
      buttonClass = _cssJSLogic.buttonClass,
      loaderParentClass = _cssJSLogic.loaderParentClass,
      loaderChildClass = _cssJSLogic.loaderChildClass;

  var statusLower = status.toLowerCase();
  return /*#__PURE__*/_react["default"].createElement("button", _extends({
    className: buttonClass,
    "data-id": disabled ? "".concat(dataId, "_disabled") : dataId,
    "data-test-id": disabled ? "".concat(dataId, "_disabled") : dataId,
    disabled: disabled || statusLower === 'loading',
    onClick: onClick,
    "data-title": title,
    type: "button",
    ref: getRef,
    "data-selector-id": dataSelectorId
  }, customProps, a11y, {
    id: id
  }), children ? children : text, statusLower !== 'none' && needAppearance && /*#__PURE__*/_react["default"].createElement("div", {
    className: finalStyle.overlay
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: loaderParentClass
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: loaderChildClass
  }))));
}

Button.defaultProps = _defaultProps.defaultProps;
Button.propTypes = _propTypes.propTypes; // if (__DOCS__) {
//   Button.docs = {
//     componentGroup: 'Form Elements',
//     folderName: 'Style Guide'
//   };
// }